<?php

/* 
 * Webbax - Scanner Antivirus
 * Plugin revisité pour assurer un scan WP & Prestashop
 */

/*
Plugin Name: php Malicious Code Scanner
Plugin URI: http://www.mikestowe.com/phpmalcode
License: GPL-2
*/

define('SEND_EMAIL_ALERTS_TO','mail@gmail.com');

class phpMalCodeScan {
        
    public $infected_files = array();
    private $scanned_files = array();

    function __construct() {
        $this->scan(dirname(__FILE__));
        $this->sendalert();
    }

    function scan($dir){
        $this->scanned_files[] = $dir;
        $files = scandir($dir);
        if(!is_array($files)) {
            throw new Exception(utf8_decode('Impossible de vérifier le dossier').' '.$dir.' '.utf8_decode('Veuillez vérifier que vous avez bien les permissions nécessaires.'));
        }
        foreach($files as $file) {
            if(is_file($dir.'/'.$file) && !in_array($dir.'/'.$file,$this->scanned_files)) {
                $this->check(file_get_contents($dir.'/'.$file),$dir.'/'.$file);
            }elseif(is_dir($dir.'/'.$file) && substr($file,0,1) != '.') {
                $this->scan($dir.'/'.$file);
            }
        }
    }

    function check($contents,$file) {      
        $this->scanned_files[] = $file;      
        if(preg_match('/eval\((base64|eval|\$_|\$\$|\$[A-Za-z_0-9\{]*(\(|\{|\[))/i',$contents)) {
            $files_wishlist_found = false;
            $files_wishlist = $this->getFilesWishlist();
            foreach($files_wishlist as $file_wishlist){
                if(strpos($file,$file_wishlist)!==false){
                    $files_wishlist_found = true;
                    break;
                }
            }
            if(!$files_wishlist_found){
                $this->infected_files[] = $file; 
            }
        }
    }
    
    function sendalert() {  
        if(count($this->infected_files) != 0){
            $title = 'Virus potentiels trouvés';
            $message = '== '.$title.' =='."\n\n".'<br/>';
            $message .= 'Ces fichiers pourraient être infectés'." : \n".'<br/><br/>';
            foreach($this->infected_files as $inf) {
                $message .= " - $inf \n".'<br/>';
            }
        }else{
            $title = 'Aucun virus détecté sur l\'hébergement';
            $message = 'Félicitation, actuellement tout semble correct !';
        } 
        echo 
        '<!doctype html>
            <html lang="fr">
            <head>
              <meta charset="utf-8">
              <title>Scanner</title>
            </head>
            <body>'.
                $message.'<br/>
                Le scan est terminé !
            </body>
        </html>'; 
        $message = str_replace('<br/>','',$message);
        mail(SEND_EMAIL_ALERTS_TO,utf8_decode($title),utf8_decode($message),'FROM:');
    }

    /*
     * Fichiers autorisés
     * @param - 
     * @return array
     */
    function getFilesWishlist(){
        $wishlist = array();
        $wishlist[] = '/wp-content/plugins/popup-by-supsystic/classes/Twig/Test/IntegrationTestCase.php';
        $wishlist[] = '/administration/themes/default/js/jquery.iframe-transport.js';
        $wishlist[] = '/tools/smarty/sysplugins/smarty_internal_function_call_handler.php';
        return $wishlist;
    }
}

ini_set('memory_limit', '-1'); 
new phpMalCodeScan;

?>
